<!DOCTYPE html>

<html lang="en-US">

<head>
  <title>[Dicas-L] Procurando e copiando arquivos com seus caminhos originais</title>
  <meta charset="UTF-8">
  <link rel="stylesheet"    type="text/css"     href="https://fonts.googleapis.com/css?family=Open+Sans&amp;display=swap">
  <link rel="stylesheet"    type="text/css"     href="https://fonts.googleapis.com/css?family=Oswald:400,700">
  <link rel="stylesheet"    type="text/css"     href="http://www.dicas-l.com.br/css/responsee.css">
  <link rel="shortcut icon" type="image/x-icon" href="http://www.dicas-l.com.br/favicon.ico">
  <link rel="icon"          type="image/gif"    href="http://www.dicas-l.com.br/animated_favicon1.gif">
</head>

<body class="size-1140">
<div class="line">
<div class="box  margin-bottom">
<div class="margin">

<aside class="s-12 l-3">
<div class="aside-nav">
<div align="center">
<p></p>
</div>
</div>
</aside>

<section class="s-12 l-6">
<div class="body" id="body">
<section>

<h1>Procurando e copiando arquivos com seus caminhos originais</h1>

<p>
<strong><em>Colaboração: Paulo Roberto Bagatini</em></strong>
</p>
<p>
<strong><em>Data de Publicação: 30 de março de 2015</em></strong>
</p>
<p>
Ao longo dos anos fui amontoando alguns arquivos .reg com configuração personalizada do PuTTY. Não é muita coisa, mas está tudo espalhado em um HD USB com mais de 1 TiB de dados e não há a menor chance de lembrar quantos são, em que diretórios estão e como se chamam; só sei que provavelmente têm "putty" no nome, alguma alternância entre maiúsculo e minúsculo, e a extensão é "reg".
</p>
<p>
Como achá-los e copiá-los automaticamente para um único diretório, cuidando para não sobrescrever os que tiverem o mesmo nome? Bom, se cada arquivo for copiado com seu caminho original para dentro do novo diretório "pai", certamente não haverá nenhuma sobreposição.
</p>
<p>
A <strong>primeira técnica</strong> será a forma rápida, limpa e suficientemente nerd de fazer isso (no Unix, MacOSX e Windows com <a href="http://goo.gl/lu6oJi">CygWin</a>): com um singelo <em>cp</em> associado a um <em>find</em>.
</p>
<p>
Primeiro preparamos adequadamente o ambiente:
</p>

<pre>$ padrao="*putty*.reg"
$ pesquisa="/longa/raiz/comum/a/todos/os/arquivos/e/que/nao/interessa/manter/"
$ destino="/diretorio/para/os/arquivos/encontrados/"
$ mkdir -p "$destino"
$ alias time="/usr/bin/time -f %E"
</pre>

<p>
Então executamos o comando:
</p>

<pre>$ ( cd "$pesquisa"; cp -va --parents $(time find . -type f -iname "$padrao") "$destino" )
</pre>

<p>
O <em>alias</em> do comando <em>time</em> é apenas um plus a mais :-p para saber em um formato user friendly quanto tempo a pesquisa do <em>find</em> demorou.
</p>
<p>
Beleza, funcionou! Em 17 min varreu 1.3 TiB e copiou 28 arquivos.
</p>
<p>
Mas como nem tudo são flores no mundo encantado da TI, esse método tem pelo menos dois pontos de falha em potencial.
</p>
<p>
Um deles é o tamanho da entrada gerada pela saída do <em>find</em>. No meu Linux 3.16.0 em arquitetura 32 bits, se todos os argumentos do <em>cp</em> resultarem em uma string com mais de 2.097.152 (=2^21, <code>bc -l &lt;&lt;&lt; "scale=5;l(2097152)/l(2)"</code> ;-) caracteres, ele vai reclamar:
</p>

<pre>$ ( cd "$pesquisa"; find . -type f -iname "$padrao" | wc -c ) # mostra com quantos bytes fica a lista de argumentos resultante do padrão
2981219
$ ( cd "$pesquisa"; cp -va --parents $(find . -type f -iname "$padrao") "$destino" )
bash: /bin/cp: Lista de argumentos muito longa
$ # ou, em inglês:
$ ( cd "$pesquisa"; LANGUAGE=C cp -va --parents $(find . -type f -iname "$padrao") "$destino" )
bash: /bin/cp: Argument list too long
</pre>

<p>
Podemos até não gostar dessa limitação de 2 MiB, mas lembremos que o "comprimento" dos comandos no terminal do Windows não passa de míseros (8Ki-1)B &gt;:-) (<a href="http://goo.gl/Yo1m1e">support.microsoft.com/pt-br/kb/830473</a>)
</p>
<p>
O tamanho que a lista de argumentos pode ter no Unix está definido na constante <strong>ARG_MAX</strong> e, pelo menos no Linux, pode ser consultado com o comando <em>getconf</em>:
</p>

<pre>$ getconf ARG_MAX
2097152
$ getconf -a            # todos as constantes
$ getconf -a | grep MAX # constantes explicitamente relacionadas a limites máximos, vale a pena uma olhada
</pre>

<p>
Alguma informação sobre o <strong>ARG_MAX</strong> está disponível em <a href="http://goo.gl/rvN5B5">in-ulm.de/~mascheck/various/argmax/</a>, inclusive uma tabela comparando seu valor em vários sistemas operacionais.
</p>
<p>
Ainda que o processo sobreviva ao risco do tamanho final da lista de parâmetros do <em>cp</em>, pode não escapar da existência de diretórios ou arquivos com espaço no nome (<code>/longa/raiz/</code><strong><code>comum a</code></strong><code>/todos/os/arquivos/e/que/nao/interessa/manter/configs/</code><strong><code>putty fileserver.reg</code></strong>):
</p>

<pre>cp: impossível obter estado de  /longa/raiz/comum : Arquivo ou diretório não encontrado
cp: impossível obter estado de  a/todos/os/arquivos/e/que/nao/interessa/manter/configs/putty : Arquivo ou diretório não encontrado
cp: impossível obter estado de  fileserver.reg : Arquivo ou diretório não encontrado
</pre>

<p>
Para contornar esse outro ponto de falha, precisamos de alguma técnica que permita deixar entre aspas o nome com caminho de cada arquivo, ou o que quer que o represente.
</p>
<p>
Ignorando a alternativa óbvia de iterar a saída do <em>find</em> em um loop, uma <strong>segunda técnica</strong> permite driblar simultaneamente o problema do tamanho da lista de argumentos e dos espaços em nomes, de pelo menos duas formas:
</p>

<ul>
<li>executando o <em>cp</em> de dentro do <em>find</em>
</li>
<li>passando o resultado do <em>find</em> via <em>xargs</em> para o <em>cp</em>
</li>
</ul>

<pre>$ ( cd "$pesquisa"; time find . -type f -iname "$padrao" -exec cp -va --parents "{}" "$destino" \; )
$ ( cd "$pesquisa"; time find . -type f -iname "$padrao" | xargs -I+ cp -va --parents "+" "$destino" )
</pre>

<p>
Por fim, uma <strong>terceira técnica</strong> combina o comando <em>find</em> com duas chamadas do comando <em>tar</em>. Tem características interessantes:
</p>

<ul>
<li>é possível compactar o stream antes da cópia, usando parâmetros do próprio <em>tar</em> ou alguma ferramenta auxiliar;
</li>
<li>aliando o comando <em>ssh</em>, é possível transferência criptografada do stream através pela rede;
</li>
<li>uma chave privada sem passphrase para o <em>ssh</em> torna desnecessária a interação humana para autenticação por senha;
</li>
<li>além da compressão por ferramentas auxiliares, o próprio <em>ssh</em> pode efetuar compressão dos dados em seu tráfego. De qualquer forma, é basicamente em redes lentas que ela será útil de fato.
</li>
</ul>

<p>
Usando <em>ssh</em>, é especialmente importante verificar se temos as permissões necessárias para criar o diretório <strong>$destino</strong>.
</p>
<p>
O <em>tar</em> pode ser usado com <em>xargs</em> para contornar o estouro do tamanho da lista de argumentos ou pode usar um arquivo com a lista de entrada a ser manipulada. Para evitar a criação explícita de um arquivo intermediário, podemos aplicar substituição de processos (<a href="http://goo.gl/Yt7ofw">apoie.org/JulioNeves/PapoXI.htm#Substitui_o_de_processos</a>, <a href="http://goo.gl/IaSYQf">wikipedia.org/wiki/Process_substitution</a>).
</p>

<pre>$ ( cd "$pesquisa"; time find . -type f -iname "$padrao" -print0 | xargs -0 tar cf - ) | tar xvf - -C "$destino"

$ ( cd "$pesquisa"; tar  cf - -T &lt;(time find . -type f -iname "$padrao") ) | tar xvf - -C "$destino"

$ chave="/arquivo/com/chave/privada/sem/passphrase"
$ remoto="user@host"

$ # compactação gzip
$ ( cd "$pesquisa"; tar  cf - -T &lt;(time find . -type f -iname "$padrao") ) | ssh -CTi "$chave" $remoto "mkdir -p '$destino'; tar  xvf - -C '$destino'"

$ # compactação bzip2
$ ( cd "$pesquisa"; tar jcf - -T &lt;(time find . -type f -iname "$padrao") ) | ssh  -Ti "$chave" $remoto "mkdir -p '$destino'; tar jxvf - -C '$destino'"

$ # compactação lzma
$ ( cd "$pesquisa"; tar  cf - -T &lt;(time find . -type f -iname "$padrao") ) | xz -9e | ssh -Ti "$chave" $remoto "mkdir -p '$destino'; xz -d | tar xvf - -C '$destino'"
</pre>

<section>
<h2>Comandos usados nesse artigo</h2>

<ul>
<li><a href="http://goo.gl/xyWEUj">bash</a>
</li>
<li><a href="http://goo.gl/4lPnHa">cp</a>
</li>
<li><a href="http://goo.gl/BYfgvT">find</a>
</li>
<li><a href="http://goo.gl/ohvUEn">getconf</a>
</li>
<li><a href="http://goo.gl/KlxUdu">grep</a>
</li>
<li><a href="http://goo.gl/kyv1cP">ssh</a>
</li>
<li><a href="http://goo.gl/uZkT7k">tar</a>
</li>
<li><a href="http://goo.gl/XOYu6o">time</a>
</li>
<li><a href="http://goo.gl/ad8FI7">wc</a>
</li>
<li><a href="http://goo.gl/v2LCEa">xargs</a>
</li>
<li><a href="http://goo.gl/39LKqs">xz</a>
</li>
</ul>
</section>

</section>
</div>
</section>
</div>
</div>
</div>
</body>
</html>
